Debian Bug report logs - #418324
xterm: baffling weirdness with 9x15 font and some Unicode glyphs

version graph

Package: xterm; Maintainer for xterm is Debian X Strike Force <debian-x@lists.debian.org>; Source for xterm is src:xterm.

Reported by: Branden Robinson <branden@debian.org>

Date: Sun, 8 Apr 2007 23:54:02 UTC

Severity: normal

Tags: upstream

Found in versions xterm/222-3, xterm/235-2

Done: Thomas Dickey <dickey@his.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#418324; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Sun, 08 Apr 2007 19:53:28 -0400
Package: xterm
Version: 222-3
Severity: normal
Tags: upstream

This is an upstream issue, I'll wager.

The root of my complaint is that the Unicode glyphs LEFT-POINTING ANGLE
BRACKET (U+2329) and RIGHT-POINTING ANGLE BRACKET (U+232A) don't render
when I size my xterms up to the "Large" font.  This was brought to my
attention because GNU roff renders URLs between these glyphs in UTF-8
environments.  (On a Debian system, an example of a manpage that uses the
.URL macro is "update-fonts-alias", but there are many others.)

At first I thought this was just an oversight in the 9x15 font, as those
glyphs render fine.  So fired up gbdfed to have a look, intending to draw
my own glyphs and submit a patch.

Imagine my surprise when I found that the font does define glyphs there.
Next I thought, well, maybe the bounding box is wrong, or it's declared as
a normal-width character but is really double-width.  Those guesses appear
to be wrong, too:

STARTCHAR angleleft
ENCODING 9001
SWIDTH 576 0
DWIDTH 9 0
BBX 9 15 0 -3
BITMAP
0000
0000
0400
0400
0800
0800
1000
1000
0800
0800
0400
0400
0000
0000
0000
ENDCHAR
STARTCHAR angleright
ENCODING 9002
SWIDTH 576 0
DWIDTH 9 0
BBX 9 15 0 -3
BITMAP
0000
0000
1000
1000
0800
0800
0400
0400
0800
0800
1000
1000
0000
0000
0000
ENDCHAR

I'm not really clear on what SWIDTH and DWIDTH are, but they (and the
bounding box "BBOX") are the same as glyph 9000 (U+2328 "KEYBOARD"), which
renders fine.

So then I thought maybe it's a bug in xterm.  After floundering a bit,
because konsole doesn't want to play with bitmap fonts and fails to
"install" them when its convoluted dialogs offer to, and gnome-terminal
wanted to install a few dozen megs of dependencies, including Epiphrany and
dvd+rw-tools (?!), I settled on rxvt-unicode-ml.

I was in for another surprise.  urxvt displays the glyphs correctly -- but
then so does xterm, when I launch it manually!  (Usually I just let the
session manager start all the xterms I use.)  What's more, both urxvt and
xterm suddenly forget how to render U+2328 and U+232B ("ERASE TO THE
LEFT"), which my usual xterms that can't render angle brackets handle just
fine!

There is one difference between urxvt and xterm -- the angle bracket glyphs
I *do* get look right on urxvt, but xterm is showing me some ugly stuff
that reminds me of the semigraphics characters on the TRS-80 Model I.

I've worked with X for a long time but this has me stumped.

What on earth is going on?

Here's my $HOME/.Xresources; as you can see, I don't change XTerm's fonts:

! Personal Xresources file

XClipboard*Form*Text*font:	fixed

XConsole.verbose:	true
XConsole*iconic:	false
XConsole*geometry:	1272x89+0-58
XConsole*saveLines:	1000
XConsole*font:		6x10

XTerm*autoWrap:		true
XTerm*curses:		true
XTerm*loginShell:	true
XTerm*reverseWrap:	true
XTerm*scrollBar:	true
XTerm*saveLines:	5000
XTerm*scrollTtyOutput:	false
XTerm*trimSelection:	true
XTerm*visualBell:	true
XTerm*activeIcon:	true
XTerm.VT100.background:	gray30
XTerm.VT100.foreground:	gray90
XTerm.VT100.geometry:	200x67-0+0
XTerm.VT100.color4:	DodgerBlue1
XTerm.VT100.color8:	gray50
XTerm.VT100.color12:	SteelBlue1
XTerm.VT100.scrollbar.background:	white
XTerm.VT100.scrollbar.foreground:	blue

UXTerm*autoWrap:		true
UXTerm*curses:			true
UXTerm*loginShell:		true
UXTerm*reverseWrap:		true
UXTerm*scrollBar:		true
UXTerm*saveLines:		5000
UXTerm*scrollTtyOutput:		false
UXTerm*trimSelection:		true
UXTerm*visualBell:		true
UXTerm*activeIcon:		true
UXTerm.VT100.background:	gray30
UXTerm.VT100.foreground:	gray90
UXTerm.VT100.geometry:		200x67-0+0
UXTerm.VT100.color4:		DodgerBlue1
UXTerm.VT100.color8:		gray50
UXTerm.VT100.color12:		SteelBlue1
UXTerm.VT100.scrollbar.background:	 white
UXTerm.VT100.scrollbar.foreground:	blue

XCalc*IconName:		xcalc

XLock.star.delay: 20000
XLock.star.batchcount: 100
XLock.star.saturation: 1.0
XLock.star.rock: on
XLock.star.trek: 0

! vim:ai:noet:sts=8:sw=8:tw=0:

-- System Information:
Debian Release: 4.0
  APT prefers oldstable
  APT policy: (500, 'oldstable'), (500, 'testing'), (500, 'stable')
Architecture: powerpc (ppc)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.15-1-powerpc-smp
Locale: LANG=C, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)

Versions of packages xterm depends on:
ii  libc6                       2.3.6.ds1-13 GNU C Library: Shared libraries
ii  libfontconfig1              2.4.2-1.2    generic font configuration library
ii  libice6                     1:1.0.1-2    X11 Inter-Client Exchange library
ii  libncurses5                 5.5-5        Shared libraries for terminal hand
ii  libsm6                      1:1.0.1-3    X11 Session Management library
ii  libx11-6                    2:1.0.3-7    X11 client-side library
ii  libxaw7                     1:1.0.2-4    X11 Athena Widget library
ii  libxext6                    1:1.0.1-2    X11 miscellaneous extension librar
ii  libxft2                     2.1.8.2-8    FreeType-based font drawing librar
ii  libxmu6                     1:1.0.2-2    X11 miscellaneous utility library
ii  libxt6                      1:1.0.2-2    X11 toolkit intrinsics library
ii  xbitmaps                    1.0.1-2      Base X bitmaps

Versions of packages xterm recommends:
ii  xutils                      1:7.1.ds.3-1 X Window System utility programs

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#418324; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 418324@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: 418324@bugs.debian.org
Subject: URL to screenshot
Date: Sun, 8 Apr 2007 19:57:11 -0400
[Message part 1 (text/plain, inline)]
I forgot to add a screen shot as documentary evidence.

http://necrotic.deadbeast.net/tmp/glyph_weirdness.png

-- 
G. Branden Robinson                |    Those who fail to remember the laws
Debian GNU/Linux                   |    of science are condemned to
branden@debian.org                 |    rediscover some of the worst ones.
http://people.debian.org/~branden/ |    -- Harold Gordon
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#418324; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 418324@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: 418324@bugs.debian.org
Subject: URL to screenshot
Date: Sun, 8 Apr 2007 20:00:27 -0400
[Message part 1 (text/plain, inline)]
Missing qualification in my bug description:

> At first I thought this was just an oversight in the 9x15 font, as those
> glyphs render fine.

That is, they render fine in all the other default xterm fonts, except
possibly for "Unreadable" (nil2).

-- 
G. Branden Robinson                |       I am not young enough to know
Debian GNU/Linux                   |       everything.
branden@debian.org                 |       -- Oscar Wilde
http://people.debian.org/~branden/ |
[signature.asc (application/pgp-signature, inline)]

Message sent on to Branden Robinson <branden@debian.org>:
Bug#418324. Full text and rfc822 format available.

Message #18 received at 418324-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 418324-submitter@bugs.debian.org
Subject: Re: Bug#418324: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Sun, 8 Apr 2007 20:27:18 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 09, 2007 at 02:00:12AM +0200, Branden Robinson wrote:
> Package: xterm
> Version: 222-3
> Severity: normal
> Tags: upstream
> 
> This is an upstream issue, I'll wager.
> 
> The root of my complaint is that the Unicode glyphs LEFT-POINTING ANGLE
> BRACKET (U+2329) and RIGHT-POINTING ANGLE BRACKET (U+232A) don't render
...
> There is one difference between urxvt and xterm -- the angle bracket glyphs
> I *do* get look right on urxvt, but xterm is showing me some ugly stuff
> that reminds me of the semigraphics characters on the TRS-80 Model I.

grep'ing the code, I see some special case in wcwidth.c (the built-in flavor)
which may be related - makes xterm treat those codes as double-width.  I expect
they're being scaled.

I have a to-do item to make it configurable whether the built-in or system
wcwidth() is used; looks like this case would be interesting to compare.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#418324; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #23 received at 418324@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: Thomas Dickey <dickey@radix.net>, 418324@bugs.debian.org
Subject: Re: Bug#418324: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Mon, 9 Apr 2007 01:14:17 -0400
[Message part 1 (text/plain, inline)]
On Sun, Apr 08, 2007 at 08:27:18PM -0400, Thomas Dickey wrote:
> grep'ing the code, I see some special case in wcwidth.c (the built-in flavor)
> which may be related - makes xterm treat those codes as double-width.  I expect
> they're being scaled.

xterm does treat them as double-width in all the default bitmap fonts in
the resources; but it's only in 9x15 that the glyph doesn't render, which
suggests to me another layer to the problem.

> I have a to-do item to make it configurable whether the built-in or system
> wcwidth() is used; looks like this case would be interesting to compare.

I did not know that character width was determined by codepoint rather than
by font-specific information, but if this is something Unicode is
standardizing, I think that's a good thing.

The code chart for this block of Unicode ("Miscellaneous Technical")[1] seems
to suggest that these glyphs should be fullwidth, or at least wide enough
to have the angle brackets "hug" the other symbols they enclose, but I find
it difficult to argue for the normativity of that observation without more
background.

[1] http://www.unicode.org/charts/PDF/U2300.pdf

-- 
G. Branden Robinson                |     If you have the slightest bit of
Debian GNU/Linux                   |     intellectual integrity you cannot
branden@debian.org                 |     support the government.
http://people.debian.org/~branden/ |     -- anonymous
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#418324; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #28 received at 418324@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: 418324@bugs.debian.org
Subject: another screenshot
Date: Mon, 9 Apr 2007 01:28:01 -0400
[Message part 1 (text/plain, inline)]
Here's another screen shot, showing the same glyphs at every one of the
stock font sizes.

http://necrotic.deadbeast.net/tmp/more_glyph_weirdness.png

-- 
G. Branden Robinson                |    Patriotism is your conviction that
Debian GNU/Linux                   |    this country is superior to all
branden@debian.org                 |    others because you were born in it.
http://people.debian.org/~branden/ |    -- George Bernard Shaw
[signature.asc (application/pgp-signature, inline)]

Message sent on to Branden Robinson <branden@debian.org>:
Bug#418324. Full text and rfc822 format available.

Message #31 received at 418324-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 418324-submitter@bugs.debian.org
Subject: Re: Bug#418324: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Mon, 9 Apr 2007 06:32:32 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 09, 2007 at 01:14:17AM -0400, Branden Robinson wrote:
> On Sun, Apr 08, 2007 at 08:27:18PM -0400, Thomas Dickey wrote:
> > grep'ing the code, I see some special case in wcwidth.c (the built-in flavor)
> > which may be related - makes xterm treat those codes as double-width.  I expect
> > they're being scaled.
> 
> xterm does treat them as double-width in all the default bitmap fonts in
> the resources; but it's only in 9x15 that the glyph doesn't render, which
> suggests to me another layer to the problem.

ok... I misread your report as pointing to the 10x20 font (the only odd thing
I recalled about that was that it doesn't have a boldface).  But it does say
9x15.  I reproduced the effect with the Huge font.
 
> > I have a to-do item to make it configurable whether the built-in or system
> > wcwidth() is used; looks like this case would be interesting to compare.

btw, at the moment the code has this option

     -mk_width
             Set the mkWidth resource to  ``true''.   This  makes
             xterm  use  a built-in version of the wide-character
             width calculation.  The default is ``false''

but internally it compares the two and given a threshold, may decide to
set it to use the build-in version (that aspect isn't configurable, iirc).

> I did not know that character width was determined by codepoint rather than
> by font-specific information, but if this is something Unicode is
> standardizing, I think that's a good thing.

more/less.  I seem to recall that chunk of wcwidth() is to make CJK stuff
work properly (will review history).
 
> The code chart for this block of Unicode ("Miscellaneous Technical")[1] seems
> to suggest that these glyphs should be fullwidth, or at least wide enough
> to have the angle brackets "hug" the other symbols they enclose, but I find
> it difficult to argue for the normativity of that observation without more
> background.
> 
> [1] http://www.unicode.org/charts/PDF/U2300.pdf

it's certainly enough to start, anyway - thanks

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Message sent on to Branden Robinson <branden@debian.org>:
Bug#418324. Full text and rfc822 format available.

Message #34 received at 418324-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 418324-submitter@bugs.debian.org
Subject: Re: Bug#418324: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Mon, 9 Apr 2007 20:21:25 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 09, 2007 at 01:14:17AM -0400, Branden Robinson wrote:
> On Sun, Apr 08, 2007 at 08:27:18PM -0400, Thomas Dickey wrote:
> > grep'ing the code, I see some special case in wcwidth.c (the built-in flavor)
> > which may be related - makes xterm treat those codes as double-width.  I expect
> > they're being scaled.
> 
> xterm does treat them as double-width in all the default bitmap fonts in
> the resources; but it's only in 9x15 that the glyph doesn't render, which
> suggests to me another layer to the problem.

Perhaps not 9x15 - in the default font, which is actually 6x13, I see the
angle brackets looking more like parentheses - and not scaled.

The scaling is "normal" - xterm lets one also specify a wide font, which
wouldn't have to be scaled.  Assuming that I don't run into problems making
a nice example of that, the bug report seems to be finding why the default
font is being treated differently for this case, and fixing that.
 
> > I have a to-do item to make it configurable whether the built-in or system
> > wcwidth() is used; looks like this case would be interesting to compare.

just in case, I checked this - it's not related to the problem.
 
-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#418324; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #39 received at 418324@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: Thomas Dickey <dickey@radix.net>, 418324@bugs.debian.org
Subject: Re: Bug#418324: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Mon, 9 Apr 2007 21:15:52 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 09, 2007 at 08:21:25PM -0400, Thomas Dickey wrote:
> On Mon, Apr 09, 2007 at 01:14:17AM -0400, Branden Robinson wrote:
> > On Sun, Apr 08, 2007 at 08:27:18PM -0400, Thomas Dickey wrote:
> > > grep'ing the code, I see some special case in wcwidth.c (the built-in flavor)
> > > which may be related - makes xterm treat those codes as double-width.  I expect
> > > they're being scaled.
> > 
> > xterm does treat them as double-width in all the default bitmap fonts in
> > the resources; but it's only in 9x15 that the glyph doesn't render, which
> > suggests to me another layer to the problem.
> 
> Perhaps not 9x15 - in the default font, which is actually 6x13, I see the
> angle brackets looking more like parentheses - and not scaled.

You're right.  The glyphs look okay in 6x13, don't get rendered at all in
9x15, and look like they've been scaled in an ugly way in the other fonts.

(nil2 excepted, as I don't know what I'm looking at there.)

-- 
G. Branden Robinson                |    The basic test of freedom is
Debian GNU/Linux                   |    perhaps less in what we are free to
branden@debian.org                 |    do than in what we are free not to
http://people.debian.org/~branden/ |    do.                  -- Eric Hoffer
[signature.asc (application/pgp-signature, inline)]

Message sent on to Branden Robinson <branden@debian.org>:
Bug#418324. Full text and rfc822 format available.

Message #42 received at 418324-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 418324-submitter@bugs.debian.org
Subject: Re: Bug#418324: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Tue, 10 Apr 2007 06:27:21 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 09, 2007 at 09:15:52PM -0400, Branden Robinson wrote:
> On Mon, Apr 09, 2007 at 08:21:25PM -0400, Thomas Dickey wrote:
> > On Mon, Apr 09, 2007 at 01:14:17AM -0400, Branden Robinson wrote:
> > > On Sun, Apr 08, 2007 at 08:27:18PM -0400, Thomas Dickey wrote:
> > > > grep'ing the code, I see some special case in wcwidth.c (the built-in flavor)
> > > > which may be related - makes xterm treat those codes as double-width.  I expect
> > > > they're being scaled.
> > > 
> > > xterm does treat them as double-width in all the default bitmap fonts in
> > > the resources; but it's only in 9x15 that the glyph doesn't render, which
> > > suggests to me another layer to the problem.
> > 
> > Perhaps not 9x15 - in the default font, which is actually 6x13, I see the
> > angle brackets looking more like parentheses - and not scaled.
> 
> You're right.  The glyphs look okay in 6x13, don't get rendered at all in
> 9x15, and look like they've been scaled in an ugly way in the other fonts.

I seem to recall some problem getting a matching 6x13bold, but looking
at a debug-trace last night, xterm _thought_ it got one.

The trace showed (for the large font case) that it was using the wide
font (derived by multiplying the width by 2 rather than the -fw option).

I'll continue investigating tonight, to see what the story regarding the
default font is.  I didn't notice a problem with any of the other sizes.
Thinking about it now - perhaps you have a stray "*" in a font resource
for 9x15 ?

(Xft fonts would be another story too ;-)
 
> (nil2 excepted, as I don't know what I'm looking at there.)

iirc, that's 2x2 (not a lot to be learned there)

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Message sent on to Branden Robinson <branden@debian.org>:
Bug#418324. Full text and rfc822 format available.

Message #45 received at 418324-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 418324-submitter@bugs.debian.org
Subject: Re: Bug#418324: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Thu, 12 Apr 2007 17:00:44 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 09, 2007 at 02:00:12AM +0200, Branden Robinson wrote:
> Package: xterm
> Version: 222-3
> Severity: normal
> Tags: upstream
> 
> This is an upstream issue, I'll wager.
> 
> The root of my complaint is that the Unicode glyphs LEFT-POINTING ANGLE
> BRACKET (U+2329) and RIGHT-POINTING ANGLE BRACKET (U+232A) don't render
> when I size my xterms up to the "Large" font.  This was brought to my
> attention because GNU roff renders URLs between these glyphs in UTF-8
> environments.  (On a Debian system, an example of a manpage that uses the
> .URL macro is "update-fonts-alias", but there are many others.)

It's the font.  "Large" is a 100 dpi font, the others are 75 dpi.
That makes it cover sizes reasonably well, but it has different
glyphs.  Actually "Small" is different too.

I took a look first with xfd at the given page 0x2300, and could see
that with "Large", the glyphs are missing.  Oddly enough for that
particular font, only those two are missing (relative to "Huge").
For "Small", most of the glyphs (other than those two, plus 4 line-drawing
glyphs) are missing.

To make it simpler to see what changes across fontsizes, I put together
a q/d curses program.  The missing glyphs show up as dotted boxes...

> 
> At first I thought this was just an oversight in the 9x15 font, as those
> glyphs render fine.  So fired up gbdfed to have a look, intending to draw
> my own glyphs and submit a patch.
> 
> Imagine my surprise when I found that the font does define glyphs there.

I'm puzzled by this part - though I've updated things recently...
( It might have changed.  Right now I can only report on what it is now ;-)

> So then I thought maybe it's a bug in xterm.  After floundering a bit,
> because konsole doesn't want to play with bitmap fonts and fails to
> "install" them when its convoluted dialogs offer to, and gnome-terminal
> wanted to install a few dozen megs of dependencies, including Epiphrany and
> dvd+rw-tools (?!), I settled on rxvt-unicode-ml.
> 
> I was in for another surprise.  urxvt displays the glyphs correctly -- but

One factor for confusion here - urxvt doesn't try to support different
sizes in the same run.  It also attempts to fill in missing glyphs from
different fonts.

> then so does xterm, when I launch it manually!  (Usually I just let the
> session manager start all the xterms I use.)  What's more, both urxvt and
> xterm suddenly forget how to render U+2328 and U+232B ("ERASE TO THE
> LEFT"), which my usual xterms that can't render angle brackets handle just
> fine!

I haven't see xterm _stop_ doing that - the glyphs are either there, or
they're not.
 
> There is one difference between urxvt and xterm -- the angle bracket glyphs
> I *do* get look right on urxvt, but xterm is showing me some ugly stuff
> that reminds me of the semigraphics characters on the TRS-80 Model I.

As noted, that's scaling.  urxvt generally uses TrueType fonts - I suspect
it's not using the bitmap fonts at all.  (Font loading differs - it might
be hard to get an exact comparison).  Anyway, I could improve the bitmap
fonts by adding the ucs workaround stuff to the bitmap fonts, and including
this case (will see).

btw, groff also sends a 0xffff code after the 0x2329 and 0x232a - offhand
I don't know why.  On some systems that displays as another dotted box.
 
-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Message sent on to Branden Robinson <branden@debian.org>:
Bug#418324. Full text and rfc822 format available.

Message #48 received at 418324-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 418324-submitter@bugs.debian.org
Subject: Re: Bug#418324: xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Sun, 15 Apr 2007 19:52:44 -0400
[Message part 1 (text/plain, inline)]
On Mon, Apr 09, 2007 at 07:20:07AM +0200, Branden Robinson wrote:
> > I have a to-do item to make it configurable whether the built-in or system
> > wcwidth() is used; looks like this case would be interesting to compare.

revisiting this, there are actually three flavors (system, builtin, and
builtin-cjk).  I put a test script and screenshots showing the last two
to give an idea of how they differ in

	ftp://invisible-island.net/temp/test-wide.zip
 
Even the font given in the script's "-fw" option doesn't have these
particular codes.  In changes toward #226, I added those to the workarounds
that get used when setting the "Line-Drawing Characters" menu entry...

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Branden Robinson <branden@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #53 received at 418324-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 418324-close@bugs.debian.org
Subject: Bug#418324: fixed in xterm 226-1
Date: Mon, 18 Jun 2007 13:47:09 +0000
Source: xterm
Source-Version: 226-1

We believe that the bug you reported is fixed in the latest version of
xterm, which is due to be installed in the Debian FTP archive:

xterm_226-1.diff.gz
  to pool/main/x/xterm/xterm_226-1.diff.gz
xterm_226-1.dsc
  to pool/main/x/xterm/xterm_226-1.dsc
xterm_226-1_i386.deb
  to pool/main/x/xterm/xterm_226-1_i386.deb
xterm_226.orig.tar.gz
  to pool/main/x/xterm/xterm_226.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 418324@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xterm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Mon, 18 Jun 2007 14:02:22 +0100
Source: xterm
Binary: xterm
Architecture: source i386
Version: 226-1
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xterm      - X terminal emulator
Closes: 12261 349142 418324 420974 421523 422521 426364 426863
Changes: 
 xterm (226-1) unstable; urgency=low
 .
   [ Branden Robinson ]
   * Remove debian/NEWS; the events it attested to (like the "upcoming 7.0
     modularization" are no longer news, and are in the past.
 .
   [ Julien Cristau ]
   * Configure with --with-tty-group=tty, to prevent security problems in case
     of buggy build environment (closes: #349142).
   * New upstream release.
     + fix  an  infinite  loop  when  showing  a  2-column character in a
       1-column screen (closes: #426863).
     + add  XF86Paste  and  SunPaste  to the default translations
       (closes: #422521, patch by Bernhard R Link).
     + improve  permissions  logic  when  closing pseudo-terminal
       (closes: #12261, patch by Nathanael Nerode, analysis by Richard
       Braakman).
     + add  a check in case someone tries to call the popup-menu() action
       on a menu which is not initialized (closes: #426364).
     + fix error-checking on internal font switching for "Selection" menu
       entry (closes: #421523).
     + amend select/paste change from patch #225 by limiting it to
       non-UTF-8/non-KOI8-R encoding (closes: #420974).
     + add  workaround  for  groff  ".URL" codes which are not present in
       some commonly-used bitmap fonts (closes: #418324).
   * Update reference to xlibs-data in xterm's description, refer to xbitmaps
     instead.
   * Build-depend on desktop-file-utils to install the new desktop files for
     xterm and uxterm, and change debian/rules and debian/xterm.install to
     install these files and the icons.
Files: 
 104129b8aabcf3498c64be24716de973 825 x11 optional xterm_226-1.dsc
 93d1f43ac3c13af86c598493f14a36f6 835862 x11 optional xterm_226.orig.tar.gz
 57ae2778e0a806deb01a41cc6fee0292 61616 x11 optional xterm_226-1.diff.gz
 94f81ecbb70c7cf120552b2a5a4bdeb2 452080 x11 optional xterm_226-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFGdovGmEvTgKxfcAwRAhbbAKCEL0Aq2kLgqYfTaeThWox3p9KYNwCePjvT
hGOcCnN7IKcs8dgUyCxOLVc=
=U44l
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 28 Jul 2007 07:27:01 GMT) Full text and rfc822 format available.

Bug unarchived. Request was from Branden Robinson <branden@debian.org> to control@bugs.debian.org. (Thu, 09 Apr 2009 06:39:32 GMT) Full text and rfc822 format available.

Bug reopened, originator not changed. Request was from Branden Robinson <branden@debian.org> to control@bugs.debian.org. (Thu, 09 Apr 2009 06:39:34 GMT) Full text and rfc822 format available.

Bug marked as found in version 235-2. Request was from Branden Robinson <branden@debian.org> to control@bugs.debian.org. (Thu, 09 Apr 2009 06:48:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#418324; Package xterm. (Mon, 08 Jun 2009 17:45:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Mon, 08 Jun 2009 17:45:02 GMT) Full text and rfc822 format available.

Message #66 received at 418324@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: control@bugs.debian.org, Thomas Dickey <dickey@radix.net>
Subject: xterm: U+2329 and U+232A (angle brackets) still not handled correctly
Date: Thu, 9 Apr 2009 02:37:43 -0400
[Message part 1 (text/plain, inline)]
unarchive 418324
reopen 418324
found 235-2
thanks

Hi Thomas,

I regret to report that Debian report #418324 does not actually appear to
be resolved, or regressed by the time of XTerm 235.

The attached screenshot should bring most relevant facts to light.

As a preliminary, note that on my system I have patched the font aliases to
provide "-unicode" variants for the stock X11 font aliases for ISO
8859-1-encoded fonts.  Those custom aliases' expansions are exhibited in
the screenshot for your perusal.

Also, my discussion is confined to the default fonts used in XTerm's (and
UXTerm's) applications-default fonts, and furthermore nil2 is excluded from
consideration.

Salient features of the screenshot:

1) The 9x15 font has glyphs at codepoints U+2329 and U+232A, as illustrated
by the xfd client.

2) A "default" uxterm which has been sized up to use the 9x15 font via the
menus continues to display the glyphs as double-wide dotted boxes, as if
the font did NOT define the glyphs.

3) When uxterm is invoked with the -fn option and given each of the stock
.font{,2,3,4,5,6} fonts as a parameter (even in their ISO-10646-encoded
forms), a crude substitution appears to be used, even for a font like 9x15
which defines the glyphs at those codepoints.

4) The exception to 3) is 6x13, a.k.a. "fixed".

I am also attaching my little "glyphs" text file, which combined with the
simple shell commands in my screenshot should constitute a crude unit test
for this bug.

Please contact me if you need further information or would like me to try
any experiments.

-- 
G. Branden Robinson                |    Build a fire for a man, and he'll
Debian GNU/Linux                   |    be warm for a day.  Set a man on
branden@debian.org                 |    fire, and he'll be warm for the
http://people.debian.org/~branden/ |    rest of his life. - Terry Pratchett
[glyph_weirdness_reborn.png (image/png, attachment)]
[glyph (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Message sent on to Branden Robinson <branden@debian.org>:
Bug#418324. (Tue, 09 Jun 2009 09:12:06 GMT) Full text and rfc822 format available.

Message #69 received at 418324-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Branden Robinson <branden@debian.org>
Cc: control@bugs.debian.org, Thomas Dickey <dickey@radix.net>
Subject: Re: xterm: U+2329 and U+232A (angle brackets) still not handled correctly
Date: Mon, 8 Jun 2009 20:47:33 -0400
[Message part 1 (text/plain, inline)]
On Thu, Apr 09, 2009 at 02:37:43AM -0400, Branden Robinson wrote:
> unarchive 418324
> reopen 418324
> found 235-2
> thanks
> 
> Hi Thomas,
> 
> I regret to report that Debian report #418324 does not actually appear to
> be resolved, or regressed by the time of XTerm 235.
> 
> The attached screenshot should bring most relevant facts to light.
> 
> As a preliminary, note that on my system I have patched the font aliases to
> provide "-unicode" variants for the stock X11 font aliases for ISO
> 8859-1-encoded fonts.  Those custom aliases' expansions are exhibited in
> the screenshot for your perusal.
> 
> Also, my discussion is confined to the default fonts used in XTerm's (and
> UXTerm's) applications-default fonts, and furthermore nil2 is excluded from
> consideration.
> 
> Salient features of the screenshot:
> 
> 1) The 9x15 font has glyphs at codepoints U+2329 and U+232A, as illustrated
> by the xfd client.

see below - the problem is that the glyphs aren't in the double-width font
that the font-server returns.

You could use the workaround that I added in patch #225, by using the
"Line-Drawing Characters" menu option - which would display "<?" and ">?" for
these cases.  (Looking at this, I see uxterm adding a blank after the "?", as
if it's not counting properly - will fix...)

> 2) A "default" uxterm which has been sized up to use the 9x15 font via the
> menus continues to display the glyphs as double-wide dotted boxes, as if
> the font did NOT define the glyphs.
> 
> 3) When uxterm is invoked with the -fn option and given each of the stock
> .font{,2,3,4,5,6} fonts as a parameter (even in their ISO-10646-encoded
> forms), a crude substitution appears to be used, even for a font like 9x15
> which defines the glyphs at those codepoints.

The crude substitution is because the runtime claims that these characters
are double-width.  So xterm looks for a double-width font - finds no resource
for fontWide, asks the font server for a double-width font.  It obliges by
returning a scaled bitmap font - which looks crude.
 
> 4) The exception to 3) is 6x13, a.k.a. "fixed".
> 
> I am also attaching my little "glyphs" text file, which combined with the
> simple shell commands in my screenshot should constitute a crude unit test
> for this bug.
> 
> Please contact me if you need further information or would like me to try
> any experiments.
> 
> -- 
> G. Branden Robinson                |    Build a fire for a man, and he'll
> Debian GNU/Linux                   |    be warm for a day.  Set a man on
> branden@debian.org                 |    fire, and he'll be warm for the
> http://people.debian.org/~branden/ |    rest of his life. - Terry Pratchett


> U+2328 KEYBOARD                     ⌨
> U+2329 LEFT-POINTING ANGLE BRACKET  〈
> U+232A RIGHT-POINTING ANGLE BRACKET 〉
> U+232B ERASE TO THE LEFT            ⌫




-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#418324; Package xterm. (Wed, 26 Sep 2012 10:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@his.com>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 26 Sep 2012 10:45:03 GMT) Full text and rfc822 format available.

Message #74 received at 418324@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@his.com>
To: 418324@bugs.debian.org
Cc: 418324-submitter@bugs.debian.org, 418324-done@bugs.debian.org
Subject: Re: #418324 xterm: baffling weirdness with 9x15 font and some Unicode glyphs
Date: Wed, 26 Sep 2012 06:43:40 -0400
[Message part 1 (text/plain, inline)]
given that the explanation was complete, suggesting a workaround and that
no further reply was given, this can be closed.

-- 
Thomas E. Dickey <dickey@invisible-island.net>
http://invisible-island.net
ftp://invisible-island.net
[signature.asc (application/pgp-signature, inline)]

Reply sent to Thomas Dickey <dickey@his.com>:
You have taken responsibility. (Wed, 26 Sep 2012 10:45:09 GMT) Full text and rfc822 format available.

Notification sent to Branden Robinson <branden@debian.org>:
Bug acknowledged by developer. (Wed, 26 Sep 2012 10:45:09 GMT) Full text and rfc822 format available.

Message sent on to Branden Robinson <branden@debian.org>:
Bug#418324. (Wed, 26 Sep 2012 10:45:13 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 25 Oct 2012 07:26:00 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 13:22:27 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.